c
      subroutine sdf_v3000_file(iun)
      implicit none

      character line_loc*512,line_prev*1024

      line_prev = ' '
      ctab_flag = 0
 10   continue
      call read_sdf_v3000_line(iun,line_loc,,ntok,ibeg,iend,ierr)
c
c---Proecess lines
      cvalue1 = line_loc(ibeg(1):iend(1))
      cvalue2 = line(_locibeg(2):iend(2))
      call uppercase(cvalue1)
      call uppercase(cvalue2)
      if(cvalue1.eq.'BEGIN'.and.cvalue2.eq.'CTAB') then
c
c--next line must be COUNTS
         call read_sdf_v3000_line
         if(cvalue1.eq.'COUNTS') then
            read(line_loc(ibeg(2):iend(2)),*)l1a_natom
            read(line_loc(ibeg(3):iend(3)),*)l1b_nbond
         else
            ierr = 1
            return
         endif
         cvalue2 = line_loc(ibeg(2):iend(2))
         call uppercase(cvalue2)
         if(cvalue1.eq.'BEGIN'.and.cvalue2.eq.'ATOM') then
            cvalue2 = line_loc(ibeg(2):iend(2))
c
c---  read atom information
            if(cvalue2.eq.'ATOM') then
               do  ia=1,l1a_natom
                  call read_sdf_v3000_line()
                  read(line_loc(ibeg(3):iend(5)),*)l1a_x(ia),l1a_y(ia)
     &                 l1a_z(ia)
                  l1a_index(ia) = line(ibeg(1):iend(1)
                  l1a_symb(ia) = line(ibeg(2):iend(2))
c
c---Take charge, mass and chirality info if they are available
                  if(ntok.gt.6) then
                     do  it=7,ntok
                        call split_item_v3000(line(ibeg(itk):iend(itk),
     &                       key,value)
                        if(key.eq.'CHG') then
                           l1a_charg(ia) = ivalue
                        elseif(key.eq.'MASS') then
                           l1a_mass(ia) = fvalue
                        elseif(key.eq.'VAL') then
                           l1a_valence(ia) = fvalue
                        elseif(key.eq.'HCOUNT') then
                           l1a_hcount = ivalue
                        elseif(key.eq.'CFG') then
                           l1a_conf(ia) = ivalue
                        endif
                     enddo
                  endif
               enddo
            endif
c
c---  next line must be END
            call read_sdf_v3000_line
            
         endif
         call read_sdf_v3000_line
         if(cvalue(1).eq.'BEGIN'.and.cvalue(2).eq.'BOND') then
c
c---  read bond information
            do  ib=1,l1b_nbond
               call read_sdf_v3000_line
               atind1 = line(ibeg(2):iend(2))
               atind2 = line(ibeg(3):iend(3))
               bond_order = line(ibeg(4):iend(4))
               do  ia=1,l1a_natom
                  if(atind1.eq.l1a_index(ia)) then
                     l1b_i1atm(ib) = ia
                     goto 300
                  endif
               enddo
               ierr = 1
               return
 300           continue
               do ia=1,l1a_natom
                  if(atind2.eq.l1a_index(ia)) then
                     l1b_i2atm(ib) = ia
                     goto 400
                  endif
               enddo
               ierr = 1
               return
 400           continue
            enddo
            if(cvalue(1).ne.'END'.or.cvalue(2).ne.'BOND') then
               ierr = 1
               return
            endif
         endif

      endif

      return
      end
c
      subroutine read_sdf_v3000_line()
      implicit none
c
c---inputs

c
c---  outputs
      integer ntok
      integer ibeg(*),iend(*)
      character line_out*(*)
c
c---locals
      integer l,l0
      character line_loc*80
c
      lin_out = ' '
      l0 = 0
 10   continue
      read(iun,'(a)')line_loc
      char = line_loc(1:7)
      call uppercase(char)
      l0 = lenstr(line_loc)
      if(char.eq.'M  V30 ') then
         call lenstr_bl(line_loc,l)
         if(line_loc(l:l).eq.'-') then
            if(l0.gt.0) then
               line_out = line_out(1:l0)//line_loc(8:l-1)
            else
               line_out = line_loc(8:l-1)
            goto 10
         else
            if(l0.gt.0) then
               line_out = line_out(1:l0)//line_loc(8:l)
            else
               line_out = line_loc(8:l)
            endif
            goto 20
         endif
      else
         ierr = 1
         return
      endif
c
      call lenstr(line_out,l)
      is = 1
      do  i=1,l
         if(line_out(i:i).eq.' ') then
            is = is + 1
         else
            goto 30
         endif
      enddo
c
      if(is.gt.l) then
         ierr = 1
         return
      endif
      ntok = 1
      ibeg(1) = is
      ip = is
 40   continue
      if(line_out(ip:ip).eq.'(') then
         ip = ip+1
         do while(line_out(ip:ip).ne.')')
            ip=ip+1
         enddo
      endif
 35   continue
      ip = ip + 1
      if(line_out(ip:ip).eq.' ') then
         iend(ntok) = ip-1
         ip = ip + 1
         if(ip.ge.l) then
            iend(ntok) = ip
            goto 300
         endif
 45      continue
         if(line_out(ip:ip).ne.' ') then
            ntok = ntok + 1
            ibeg(ntok) = ip
            goto 45
         endif
         goto 35
      endif
c
c--Now process the line
      do  i=1,ntok
         cvalue(i) = line(ibeg(i):iend(i))
         call uppercase(cvalue(i))
      enddo
c
      do  i=1,ntok
         ie = index(cvalue(i),'='
         if(ie.gt.0) then
c
c--keywords
            ikey = ikey + 1
            keyw(ikey) = cvalue(i)(1:ie-1)
            call lenstr(cvalue(i),ice)
            keyval(i) = cvalue(i)(ie+1:ice)
c
c--Check if it is number
            call check_number(keyval,value,key_flag)
            key_type(ikey) = 'C'
            if(key_flag) then
               key_type(ikey) = 'I'
            endif
         endif
      enddo
      return
      end
